;Chaos Functions by Shane Kennedy
;This will not compile into a fully working program but contains the basic 
;funtions needed to produce my Chaos application
;http://www.dpw-shane.pwp.blueyonder.co.uk/blitzbasic.htm

;This is free to use in non-commercial products but please credit me if you do use it

;types
Type complex
	Field x#, y#
End Type


;variables
Global index = 4				;index for NEwton-Raphson Method
Global maxiterations = 30       ;the number of iterations that will be performed
Dim NRSolutions#(11,11,2)		;Array of Solutions for N-R method
Global result.complex			;global complex number



Function DrawNRmethod()

	Viewport 20, 60, 600, 400
	
	xmin# = -1.5
	xmax# = 1.5
	ymin# = -1.25
	ymax# = 1.25
	
	SetBuffer FrontBuffer()
	
	For j = 0 To 399   
		If wanttoexit = True Then Exit
		For i = 0 To 599 
			result\x = xmin + (xmax - xmin) * i / 600
			result\y = ymin + (ymax - ymin) * j / 400
            continue = True
            iteration = 0
            ; check if within bounds 
            For count = 1 To index
            	If (result\x - NRSolutions(index, count, 0))*(result\x - NRSolutions(index, count, 0)) + (result\y - NRSolutions(index, count, 1))*(result\y - NRSolutions(index, count, 1)) < 0.01 Then
                	continue = False
                    colour = count
               	End If
			Next
            If result\x*result\x + result\y*result\y < 0.00001 Then
            	continue = False
                colour = 0
            End If
            While continue = True
            	;perform next iteration
                NewtonRaphson(result\x, result\y, index)
                ; check if within bounds
                For count = 1 To index 
                	If (result\x - NRSolutions(index, count, 0))*(result\x - NRSolutions(index, count, 0)) + (result\y - NRSolutions(index, count, 1))*(result\y - NRSolutions(index, count, 1)) < 0.01 Then
                    	continue = False
                        colour = count
                    End If
                Next
                If result\x*result\x + result\y*result\y < 0.00001 Then
                	continue = False
                    colour = 0
				Else
					iteration = iteration + 1
 	               If iteration > maxiterations Then
    	            	continue = False
        	            colour = 0
            	    End If
                End If
       		Wend
			Select colour
				Case 0
					col = 0
				Case 1
					col = 31*(iteration Mod 9)
				Case 2
					col = 7936*(iteration Mod 9)
				Case  3
					col = 2031616*(iteration Mod 9)
				Case 4
					col = 7967*(iteration Mod 9)
				Case 5
					col = 2031647*(iteration Mod 9)
				Case 6
					col = 2039552*(iteration Mod 9)
				Case 7
					col = 986911*(iteration Mod 9)
				Case 8
					col = 990991*(iteration Mod 9)
				Case 9
					col = 2035471*(iteration Mod 9)
				Case 10
					col = 991007*(iteration Mod 9)
				Case 11
					col = 2035471*(iteration Mod 9)
				Default
					col = 2039567*(iteration Mod 9)
			End Select
			
			red = col Shr 16 And $FF
			green = col Shr 8 And $FF
			blue = col And $FF
			
			Color red,green,blue
			
			Rect i+20,j+60,1,1

			If KeyHit(1) Then 
				wanttoexit = True
				Exit
			End If
  		Next
	Next
	
	SetBuffer BackBuffer()
	
	Viewport 0, 0, 640, 480

End Function

Function DrawMandelbrot(xmin#, xmax#, ymin#, ymax#)
	
	Viewport 20, 60, 600, 400
	
	original.complex = New complex
	
	SetBuffer FrontBuffer()
	
	For j = 0 To 399
		If wanttoexit = True Then Exit
		For i = 0 To 599
			;turn the pixel numbers into [x, y] co-ordinates of the graph 
			;there are 600 pixels across the iamge by 400 down the image
			result\x = xmin + (xmax - xmin) * i / 600
			result\y = ymin + (ymax - ymin) * j / 400
			original\x = result\x
			original\y = result\y
			continue = True
			iteration = 0
			;check if within bounds (if point is outside circle radius 3 then it runs to infinity
			;but the larger the radius checked the smoother the iterative bands of colour)
			If result\x * result\x + result\y * result\y > 9 Then
        		continue = False
          		colour = 0
     		End If
			While continue = True
				;perform next iteration
				ComplexRaise(result\x, result\y, 2)
				
				AddComplex(result\x, result\y, original\x, original\y)
								
            	; check if within bounds
      			If result\x * result\x + result\y * result\y > 9 Then
					continue = False
					colour = (Floor(iteration / 32.0) Mod 14)
				Else
					iteration = iteration + 1
					If iteration > maxiterations Then
						continue = False
						colour = 13
					End If
				End If
			Wend
			Select colour
				Case 0
					col = ((iteration Mod 16) + 1) * 2827
				Case 1
					col = ((iteration Mod 16) + 1) * 11
				Case 2
					col = ((iteration Mod 16) + 1) * 2816
				Case  3
					col = ((iteration Mod 16) + 1) * 720896
				Case 4
					col = ((iteration Mod 16) + 1) * 723723
				Case 5
					col = ((iteration Mod 16) + 1) * 720907
				Case 6
					col = ((iteration Mod 16) + 1) * 723712
				Case 7
					col = ((iteration Mod 16) + 1) * 328971
				Case 8
					col = ((iteration Mod 16) + 1) * 330501
				Case 9
					col = ((iteration Mod 16) + 1) * 722181
				Case 10
					col = ((iteration Mod 16) + 1) * 330507
				Case 11
					col = ((iteration Mod 16) + 1) * 722187
				Case 12
					col = ((iteration Mod 16) + 1) * 723717
				Default
					col = 0
			End Select
			
			red = col Shr 16 And $FF
			green = col Shr 8 And $FF
			blue = col And $FF
			
			Color red,green,blue
			
			Rect i+20,j+60,1,1
			
			If KeyHit(1) Then 
				wanttoexit = True
				Exit
			End If
		Next
	Next
	
	SetBuffer BackBuffer()
	
	Viewport 0, 0, 640, 480
	
	Delete original

End Function

Function DrawJulia(conx#, cony#, xmin#, xmax#, ymin#, ymax#)

	Viewport 20, 60, 600, 400
	
	cons.complex = New complex
	cons\x = conx
	cons\y = cony
	
	SetBuffer FrontBuffer()
	
	For j = 0 To 399
		If wanttoexit = True Then Exit
		For i = 0 To 599
			;turn the pixel numbers into [x, y] co-ordinates of the graph 
			;there are 600 pixels across the iamge by 400 down the image
			result\x = xmin + (xmax - xmin) * i / 600
			result\y = ymin + (ymax - ymin) * j / 400
			continue = True
			iteration = 0
			;check if within bounds (if point is outside circle radius 2 then it runs to infinity)
			If result\x * result\x + result\y * result\y > 4 Then
        		continue = False
          		colour = (Floor(iteration / 14.0) Mod 14)
     		End If
			While continue = True
				;perform next iteration
				ComplexRaise(result\x, result\y, 2)
				
				AddComplex(result\x, result\y, cons\x, cons\y)

            	; check if within bounds
				If result\x * result\x + result\y * result\y > 4 Then
					continue = False
					colour = (Floor(iteration / 14.0) Mod 14)
				Else
					iteration = iteration + 1
					If iteration > maxiterations Then
						continue = False
						colour = 13
					End If
				End If
			Wend

			Select colour
				Case 0
					col = ((iteration Mod 8) + 1) * 22
				Case 1
					col = ((iteration Mod 8) + 1) * 1441792
				Case 2
					col = ((iteration Mod 8) + 1) * 5632
				Case  3
					col = ((iteration Mod 8) + 1) * 5654
				Case 4
					col = ((iteration Mod 8) + 1) * 1447446
				Case 5
					col = ((iteration Mod 8) + 1) * 1441814
				Default
					col = ((iteration Mod 8) + 1) * 0
			End Select
			red = col Shr 16 And $FF
			green = col Shr 8 And $FF
			blue = col And $FF
			
			Color red,green,blue
			
			Rect i+20,j+60,1,1

			If KeyHit(1) Then 
				wanttoexit = True
				Exit
			End If
		Next
	Next
	
	SetBuffer BackBuffer()
	
	Viewport 0, 0, 640, 480
	
	Delete cons

End Function

Function DrawSierpinski(maxplots)

	Viewport 20, 60, 600, 400
	
	vert1.complex = New complex
	vert2.complex = New complex
	vert3.complex = New complex
	point.complex = New complex
	
	vert1\x = 300
    vert1\y = 380
	vert2\x = 20
    vert2\y = 20
    vert3\x = 580
    vert3\y = 20
    point\x = 20
    point\y = 20
    count = 0
    
	While count < maxplots
		i = Rand(1,3)
		Select i
			Case 1
				point\x = (point\x + vert1\x)/2
				point\y = (point\y + vert1\y)/2
				WritePixel point\x + 20, point\y + 60, 16711680, FrontBuffer()
			Case 2
				point\x = (point\x + vert2\x)/2
				point\y = (point\y + vert2\y)/2
				WritePixel point\x + 20, point\y + 60, 65280, FrontBuffer()
			Case 3
				point\x = (point\x + vert3\x)/2
				point\y = (point\y + vert3\y)/2
				WritePixel point\x + 20, point\y + 60, 255, FrontBuffer()
		End Select
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete vert1
	Delete vert2
	Delete vert3
	Delete point

End Function

Function DrawSquare(maxplots)

	Viewport 20, 60, 600, 400
	
	vert1.complex = New complex
	vert2.complex = New complex
	vert3.complex = New complex
	vert4.complex = New complex
	vert5.complex = New complex
	vert6.complex = New complex
	vert7.complex = New complex
	vert8.complex = New complex
	point.complex = New complex
	
	vert1\x = 20
    vert1\y = 20
	vert2\x = 300
    vert2\y = 20
    vert3\x = 580
    vert3\y = 20
	vert4\x = 20
	vert4\y = 200
	vert5\x = 580
    vert5\y = 200
	vert6\x = 20
    vert6\y = 380
    vert7\x = 300
    vert7\y = 380
	vert8\x = 580
	vert8\y = 380
    point\x = 20
    point\y = 20
    count = 0
    
	While count < maxplots
		i = Rand(1,8)
		Select i
			Case 1
				point\x = (point\x + 2*vert1\x)/3
				point\y = (point\y + 2*vert1\y)/3
				WritePixel point\x + 20, point\y + 60, 16711680, FrontBuffer()
			Case 2
				point\x = (point\x + 2*vert2\x)/3
				point\y = (point\y + 2*vert2\y)/3
				WritePixel point\x + 20, point\y + 60, 65280, FrontBuffer()
			Case 3
				point\x = (point\x + 2*vert3\x)/3
				point\y = (point\y + 2*vert3\y)/3
				WritePixel point\x + 20, point\y + 60, 255, FrontBuffer()
			Case 4
				point\x = (point\x + 2*vert4\x)/3
				point\y = (point\y + 2*vert4\y)/3
				WritePixel point\x + 20, point\y + 60, 16776960, FrontBuffer()
			Case 5
				point\x = (point\x + 2*vert5\x)/3
				point\y = (point\y + 2*vert5\y)/3
				WritePixel point\x + 20, point\y + 60, 16711935, FrontBuffer()
			Case 6
				point\x = (point\x + 2*vert6\x)/3
				point\y = (point\y + 2*vert6\y)/3
				WritePixel point\x + 20, point\y + 60, 65535, FrontBuffer()
			Case 7
				point\x = (point\x + 2*vert7\x)/3
				point\y = (point\y + 2*vert7\y)/3
				WritePixel point\x + 20, point\y + 60, 10064016, FrontBuffer()
			Case 8
				point\x = (point\x + 2*vert8\x)/3
				point\y = (point\y + 2*vert8\y)/3
				WritePixel point\x + 20, point\y + 60, 5282128, FrontBuffer()
		End Select
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete vert1
	Delete vert2
	Delete vert3
	Delete vert4
	Delete vert5
	Delete vert6
	Delete vert7
	Delete vert8
	Delete point

End Function

Function DrawFern1(maxplots)

	Viewport 20, 60, 600, 400
	
	point.complex = New complex
	temp.complex = New complex
	
	xmin# = -6
	xmax# = 6
	ymin# = 0
	ymax# = 11
	
    point\x = 0
    point\y = 0
    count = 0
    
	xtemp# = 600*(point\x - xmin)/(xmax - xmin)
	ytemp# = 400*(point\y - ymin)/(ymax - ymin)
	
	While count < maxplots
		i = Rand(1,100)
		If i = 1 Then
			point\x = 0
			point\y = (point\y)/6
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
		End If
		If i > 1 And i < 87 Then
			temp\x = (point\x)*0.85 
			temp\y = (point\y)*0.85 + 1.6
			point\x = temp\x
			point\y = temp\y
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
		End If
		If i > 86 And i < 94 Then
			temp\x = (point\x)*0.20 - (point\y)*0.26 
			temp\y = (point\x)*0.23 + (point\y)*0.22 + 1.6
			point\x = temp\x
			point\y = temp\y
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
		End If
		If i > 93 Then
			temp\x = -(point\x)*0.15 + (point\y)*0.28 
			temp\y = (point\x)*0.26 + (point\y)*0.24 + 0.44
			point\x = temp\x
			point\y = temp\y
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 16776960, FrontBuffer()
		End If
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete point
	Delete temp

End Function

Function DrawFern2(maxplots)

	Viewport 20, 60, 600, 400
	
	point.complex = New complex
	temp.complex = New complex
	
	xmin# = -5
	xmax# = 5
	ymin# = 0
	ymax# = 10
	
    point\x = 0
    point\y = 0
    count = 0
    
	xtemp# = 600*(point\x - xmin)/(xmax - xmin)
	ytemp# = 400*(point\y - ymin)/(ymax - ymin)
	
	While count < maxplots
		i = Rand(1,100)
		If i = 1 Then
			point\x = 0
			point\y = (point\y)/6
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
		End If
		If i > 1 And i < 87 Then
			temp\x = (point\x)*0.85 + (point\y)*0.04 
			temp\y = -(point\x)*0.04 + (point\y)*0.85 + 1.6
			point\x = temp\x
			point\y = temp\y
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
		End If
		If i > 86 And i < 94 Then
			temp\x = (point\x)*0.20 - (point\y)*0.26 
			temp\y = (point\x)*0.23 + (point\y)*0.22 + 1.6
			point\x = temp\x
			point\y = temp\y
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
		End If
		If i > 93 Then
			temp\x = -(point\x)*0.15 + (point\y)*0.28 
			temp\y = (point\x)*0.26 + (point\y)*0.24 + 0.44
			point\x = temp\x
			point\y = temp\y
			xtemp# = 600*(point\x - xmin)/(xmax - xmin)
			ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
			WritePixel xtemp + 20, ytemp + 60, 16776960, FrontBuffer()
		End If
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete point
	Delete temp

End Function

Function DrawFern3(maxplots)

	Viewport 20, 60, 600, 400
	
	point.complex = New complex
	temp.complex = New complex
	
	xmin# = -1.75
	xmax# = 1.75
	ymin# = -0.5
	ymax# = 2.25
	
    point\x = 0
    point\y = 0
    count = 0
    
	xtemp# = 600*(point\x - xmin)/(xmax - xmin)
	ytemp# = 400*(point\y - ymin)/(ymax - ymin)
	
	While count < maxplots
		Select Rand(1,6)
			Case 1
				temp\x = ((point\x)*Cos(0) + (point\y)*Sin(0))*0.03 + 0
				temp\y = (-(point\x)*Sin(0) + (point\y)*Cos(0))*0.6 + 0
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
			Case 2
				temp\x = ((point\x)*Cos(0) + (point\y)*Sin(0))*0.03 + 0
				temp\y = -(-(point\x)*Sin(0) + (point\y)*Cos(0))*0.5 + 1
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
			Case 3
				temp\x = ((point\x)*Cos(40) + (point\y)*Sin(40))*0.6 + 0
				temp\y = (-(point\x)*Sin(40) + (point\y)*Cos(40))*0.5 + 0.6
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
			Case 4
				temp\x = ((point\x)*Cos(20) + (point\y)*Sin(20))*0.5 + 0
				temp\y = (-(point\x)*Sin(20) + (point\y)*Cos(20))*0.45 + 1.1
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16776960, FrontBuffer()
			Case 5
				temp\x = ((point\x)*Cos(-30) + (point\y)*Sin(-30))*0.5 + 0 
				temp\y = (-(point\x)*Sin(-30) + (point\y)*Cos(-30))*0.55 + 1
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711935, FrontBuffer()
			Case 6
				temp\x = ((point\x)*Cos(-40) + (point\y)*Sin(-40))*0.55 + 0
				temp\y = (-(point\x)*Sin(-40) + (point\y)*Cos(-40))*0.4 + 0.7
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65535, FrontBuffer()
		End Select
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete point
	Delete temp

End Function

Function DrawKochCurve(maxplots)

	Viewport 20, 60, 600, 400
	
	point.complex = New complex
	temp.complex = New complex
	
	xmin# = -0.5
	xmax# = 3.5
	ymin# = -1
	ymax# = 1.5
	
    point\x = 0
    point\y = 0
    count = 0
    
	xtemp# = 600*(point\x - xmin)/(xmax - xmin)
	ytemp# = 400*(point\y - ymin)/(ymax - ymin)
	
	While count < maxplots
		i = Rand(1,4)
		Select i
			Case 1 
				point\x = (point\x)/3
				point\y = (point\y)/3
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
			Case 2
				point\x = (point\x)/3 + 2
				point\y = (point\y)/3
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
			Case 3
				temp\x = (point\x)/6 + (point\y)*0.866/3 + 1.5
				temp\y = -(point\x)*0.866/3 + (point\y)/6 + 0.866
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
			Case 4
				temp\x = (point\x)/6 - (point\y)*0.866/3 + 1 
				temp\y = (point\x)*0.866/3 + (point\y)/6
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16776960, FrontBuffer()
		End Select
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete point
	Delete temp

End Function

Function DrawRandomKochCurve(maxplots)

	Viewport 20, 60, 600, 400
	
	point.complex = New complex
	temp.complex = New complex
	
	xmin# = -0.5
	xmax# = 3.5
	ymin# = -1
	ymax# = 1.5
	
    point\x = 0
    point\y = 0
    count = 0
    
	xtemp# = 600*(point\x - xmin)/(xmax - xmin)
	ytemp# = 400*(point\y - ymin)/(ymax - ymin)
	
	R1 = Rand(0,1)
	R2 = Rand(0,1)
	R3 = Rand(0,1)
	R4 = Rand(0,1)
	
	While count < maxplots
		
		i = Rand(1,4)
		Select i
			Case 1 
				point\x = (point\x)/3
				point\y = (2*R1 - 1)*(point\y)/3
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
			Case 2
				point\x = (point\x)/3 + 2
				point\y = (2*R2 - 1)*(point\y)/3
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
			Case 3
				temp\x = (point\x)/6 + (2*R3 - 1)*(point\y)*0.866/3 + 1.5
				temp\y = -(point\x)*0.866/3 + (2*R3 - 1)*(point\y)/6 + 0.866
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
			Case 4
				temp\x = (point\x)/6 - (2*R4 - 1)*(point\y)*0.866/3 + 1 
				temp\y = (point\x)*0.866/3 + (2*R4 - 1)*(point\y)/6
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16776960, FrontBuffer()
		End Select
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete point
	Delete temp

End Function

Function DrawKochSnowflakes(maxplots)

	Viewport 20, 60, 600, 400
	
	point.complex = New complex
	temp.complex = New complex
	temp3.complex = New complex
	
	xmin# = -1.5
	xmax# = 4.5
	ymin# = -3
	ymax# = 1.5
	
    point\x = 0
    point\y = 0
    count = 0
    
	xtemp# = 600*(point\x - xmin)/(xmax - xmin)
	ytemp# = 400*(point\y - ymin)/(ymax - ymin)
	
	While count < maxplots
		i = Rand(1,4)
		Select i
			Case 1 
				point\x = (point\x)/3
				point\y = (point\y)/3
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
				temp3\x = - (point\x)/2 - (point\y)*0.866 + 1.5 
				temp3\y = (point\x)*0.866 - (point\y)/2 - 2.598
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
				temp3\x = - (point\x)/2 + (point\y)*0.866 + 3 
				temp3\y = - (point\x)*0.866 - (point\y)/2
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
			Case 2
				point\x = (point\x)/3 + 2
				point\y = (point\y)/3
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
				temp3\x = - (point\x)/2 - (point\y)*0.866 + 1.5 
				temp3\y = (point\x)*0.866 - (point\y)/2 - 2.598
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
				temp3\x = - (point\x)/2 + (point\y)*0.866 + 3 
				temp3\y = - (point\x)*0.866 - (point\y)/2
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
			Case 3
				temp\x = (point\x)/6 + (point\y)*0.866/3 + 1.5
				temp\y = -(point\x)*0.866/3 + (point\y)/6 + 0.866
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
				temp3\x = - (point\x)/2 - (point\y)*0.866 + 1.5 
				temp3\y = (point\x)*0.866 - (point\y)/2 - 2.598
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
				temp3\x = - (point\x)/2 + (point\y)*0.866 + 3 
				temp3\y = - (point\x)*0.866 - (point\y)/2
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
			Case 4
				temp\x = (point\x)/6 - (point\y)*0.866/3 + 1 
				temp\y = (point\x)*0.866/3 + (point\y)/6
				point\x = temp\x
				point\y = temp\y
				xtemp# = 600*(point\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(point\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 255, FrontBuffer()
				temp3\x = - (point\x)/2 - (point\y)*0.866 + 1.5 
				temp3\y = (point\x)*0.866 - (point\y)/2 - 2.598
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 16711680, FrontBuffer()
				temp3\x = - (point\x)/2 + (point\y)*0.866 + 3 
				temp3\y = - (point\x)*0.866 - (point\y)/2
				xtemp# = 600*(temp3\x - xmin)/(xmax - xmin)
				ytemp# = 400 - 400*(temp3\y - ymin)/(ymax - ymin)
				WritePixel xtemp + 20, ytemp + 60, 65280, FrontBuffer()
		End Select
		count = count + 1
		If KeyHit(1) Then 
			Exit
		End If
	Wend
	
	Viewport 0, 0, 640, 480
	
	Delete point
	Delete temp
	Delete temp3

End Function

Function MultiplyComplex#(c1x#, c1y#, c2x#, c2y#)

	result\x = c1x * c2x - c1y * c2y
	result\y = c1y * c2x + c1x * c2y

End Function

Function AddComplex#(c1x#, c1y#, c2x#, c2y#)

	result\x = c1x + c2x
	result\y = c1y + c2y

End Function

Function SubtractComplex#(c1x#, c1y#, c2x#, c2y#)

	result\x = c1x - c2x
	result\y = c1y - c2y

End Function

Function ComplexRaise#(c1x#, c1y#, i)

	complextemp1.complex = New complex
	complextemp2.complex = New complex
	
    complextemp1\x = 1
    For count = 1 To i 
    	complextemp2\x = c1x * complextemp1\x - c1y * complextemp1\y
		complextemp1\y = c1y * complextemp1\x + c1x * complextemp1\y
		complextemp1\x = complextemp2\x
	Next
	
	result\x = complextemp1\x
	result\y = complextemp1\y
	
	Delete complextemp1
	Delete complextemp2 
	
End Function

Function RealRaise#(r1#, i)
     
	answer# = 1
    For count = 1 To i
         answer = answer * r1
	Next
	
	Return answer
	
End Function

Function DivideComplexReal#(c1x#, c1y#, r1#)
	
	result\x = c1x / r1
	result\y = c1y / r1

End Function

Function NewtonRaphson#(c1x#, c1y#, i)

	temp2.complex = New complex
    temp2\x = c1x
    temp2\y = -c1y
	temp3.complex = New complex
	temp4.complex = New complex
	
	ComplexRaise(c1x, c1y, i)
	temp3\x = result\x
	temp3\y = result\y
	
	ComplexRaise(temp2\x, temp2\y , i - 1)
	temp4\x = result\x
	temp4\y = result\y
	
	MultiplyComplex(temp3\x, temp3\y, temp4\x, temp4\y)     
	
	SubtractComplex(result\x, result\y, temp4\x, temp4\y)
	
	DivideComplexReal(result\x, result\y, i * RealRaise(c1x * c1x + c1y * c1y, i - 1))
	
	result\x = c1x - result\x
	result\y = c1y - result\y
		
	Delete temp2
	Delete temp3
	Delete temp4
	
End Function

Function setupsolutions()

	NRSolutions(2, 1, 0) = 1
	NRSolutions(2, 1, 1) = 0
	NRSolutions(2, 2, 0) = -1
	NRSolutions(2, 2, 1) = 0
	NRSolutions(3, 1, 0) = 1
	NRSolutions(3, 1, 1) = 0
	NRSolutions(3, 2, 0) = -0.5
	NRSolutions(3, 2, 1) = 0.866
	NRSolutions(3, 3, 0) = -0.5
	NRSolutions(3, 3, 1) = -0.866
	NRSolutions(4, 1, 0) = 1
	NRSolutions(4, 1, 1) = 0
	NRSolutions(4, 2, 0) = -1
	NRSolutions(4, 2, 1) = 0
	NRSolutions(4, 3, 0) = 0
	NRSolutions(4, 3, 1) = 1
	NRSolutions(4, 4, 0) = 0
	NRSolutions(4, 4, 1) = -1
	NRSolutions(5, 1, 0) = 1
	NRSolutions(5, 1, 1) = 0
	NRSolutions(5, 2, 0) = 0.309
	NRSolutions(5, 2, 1) = 0.951
	NRSolutions(5, 3, 0) = 0.309
	NRSolutions(5, 3, 1) = -0.951
	NRSolutions(5, 4, 0) = -0.809
	NRSolutions(5, 4, 1) = 0.588
	NRSolutions(5, 5, 0) = -0.809
	NRSolutions(5, 5, 1) = -0.588
	NRSolutions(6, 1, 0) = 1
	NRSolutions(6, 1, 1) = 0
	NRSolutions(6, 2, 0) = -1
	NRSolutions(6, 2, 1) = 0
	NRSolutions(6, 3, 0) = 0.5
	NRSolutions(6, 3, 1) = 0.866
	NRSolutions(6, 4, 0) = 0.5
	NRSolutions(6, 4, 1) = -0.866
	NRSolutions(6, 5, 0) = -0.5
	NRSolutions(6, 5, 1) = 0.866
	NRSolutions(6, 6, 0) = -0.5
	NRSolutions(6, 6, 1) = -0.866
	NRSolutions(7, 1, 0) = 1
	NRSolutions(7, 1, 1) = 0
	NRSolutions(7, 2, 0) = 0.624
	NRSolutions(7, 2, 1) = 0.782
	NRSolutions(7, 3, 0) = 0.624
	NRSolutions(7, 3, 1) = -0.782
	NRSolutions(7, 4, 0) = -0.223
	NRSolutions(7, 4, 1) = 0.975
	NRSolutions(7, 5, 0) = -0.223
	NRSolutions(7, 5, 1) = -0.975
	NRSolutions(7, 6, 0) = -0.901
	NRSolutions(7, 6, 1) = 0.434
	NRSolutions(7, 7, 0) = -0.901
	NRSolutions(7, 7, 1) = -0.434
	NRSolutions(8, 1, 0) = 1
	NRSolutions(8, 1, 1) = 0
	NRSolutions(8, 2, 0) = -1
	NRSolutions(8, 2, 1) = 0
	NRSolutions(8, 3, 0) = 0
	NRSolutions(8, 3, 1) = 1
	NRSolutions(8, 4, 0) = 0
	NRSolutions(8, 4, 1) = -1
	NRSolutions(8, 5, 0) = 0.707
	NRSolutions(8, 5, 1) = 0.707
	NRSolutions(8, 6, 0) = 0.707
	NRSolutions(8, 6, 1) = -0.707
	NRSolutions(8, 7, 0) = -0.707
	NRSolutions(8, 7, 1) = 0.707
	NRSolutions(8, 8, 0) = -0.707
	NRSolutions(8, 8, 1) = -0.707
	NRSolutions(9, 1, 0) = 1
	NRSolutions(9, 1, 1) = 0
	NRSolutions(9, 2, 0) = 0.766
	NRSolutions(9, 2, 1) = 0.643
	NRSolutions(9, 3, 0) = 0.766
	NRSolutions(9, 3, 1) = -0.643
	NRSolutions(9, 4, 0) = 0.174
	NRSolutions(9, 4, 1) = 0.985
	NRSolutions(9, 5, 0) = 0.174
	NRSolutions(9, 5, 1) = -0.985
	NRSolutions(9, 6, 0) = -0.5
	NRSolutions(9, 6, 1) = 0.866
	NRSolutions(9, 7, 0) = -0.5
	NRSolutions(9, 7, 1) = -0.866
	NRSolutions(9, 8, 0) = -0.94
	NRSolutions(9, 8, 1) = 0.342
	NRSolutions(9, 9, 0) = -0.94
	NRSolutions(9, 9, 1) = -0.342
	NRSolutions(10, 1, 0) = 1
	NRSolutions(10, 1, 1) = 0
	NRSolutions(10, 2, 0) = 0.309
	NRSolutions(10, 2, 1) = 0.951
	NRSolutions(10, 3, 0) = 0.309
	NRSolutions(10, 3, 1) = -0.951
	NRSolutions(10, 4, 0) = 0.809
	NRSolutions(10, 4, 1) = 0.588
	NRSolutions(10, 5, 0) = 0.809
	NRSolutions(10, 5, 1) = -0.588
	NRSolutions(10, 6, 0) = -1
	NRSolutions(10, 6, 1) = 0
	NRSolutions(10, 7, 0) = -0.309
	NRSolutions(10, 7, 1) = 0.951
	NRSolutions(10, 8, 0) = -0.309
	NRSolutions(10, 8, 1) = -0.951
	NRSolutions(10, 9, 0) = -0.809
	NRSolutions(10, 9, 1) = 0.588
	NRSolutions(10, 10, 0) = -0.809
	NRSolutions(10, 10, 1) = -0.588

End Function


End